#include <iostream>
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include <SDL2/SDL_thread.h>
#include <SDL2/SDL_ttf.h>
#include <SDL2/SDL_mixer.h>
#include <stdlib.h>
#include <fstream>
#include <string>
#include <sstream> 
#include <filesystem>
#include <algorithm>
#define Maximum(a, b) ((a > b) ? a : b)
#define Minimum(a, b) ((a < b) ? a : b)

SDL_DisplayMode DMode;
SDL_Window* Window = NULL;
SDL_Renderer* Renderer = NULL; //mystic thing, brings an image to the screen
SDL_Surface* CurrentSurface = NULL;
SDL_Surface* ScreenSurface = NULL; 
SDL_Rect Reader;
SDL_Rect Writer;
SDL_Event event;
std::string speicher;
TTF_Font *gFont[5];
int FullScreen=true;
bool AntiA=true;
bool running=true;
bool Mono=false;
int MedianMode=1; //0=Ratio, 1=Median, 2=Color Pick
float MedianPoint=0.5;
bool PaletteMode=false;
float Zoomfactor=1;

SDL_Texture* Images[1000];



SDL_Surface* RawImages[1000];
int texturesUsed=0;

int Jumper=1;

int CTex=1;

SDL_Color CArr[10000];
SDL_Color CArr2[10000];
int cNumb=0;

short int RArr[100000];
short int BArr[100000];
short int GArr[100000];

float RefX=100;
float RefY=100;
float RefZ=100;

std::string Paths[1000];
int Pathn=0;



class Palette
{
	public:
	 SDL_Color Clrs[1000];
	 SDL_Color ClrPoints[1000];
	 int ActiveClrs=0;
	 
	 float DistToColor(float r, float g, float b, int n)
	 {
		 float re=0;
		 float var_R = ( r / 255 );
		 float var_G = ( g / 255 );
		 float var_B = ( b / 255 );

		if (var_R>0.04045) 
		var_R = std::pow(((var_R+0.055)/ 1.055 ), 2.4);
		else var_R = var_R / 12.92;
		if ( var_G > 0.04045 ) var_G = std::pow(( ( var_G + 0.055 ) / 1.055 ), 2.4);
		else var_G = var_G / 12.92;
		if ( var_B > 0.04045 ) var_B = std::pow(( ( var_B + 0.055 ) / 1.055 ), 2.4);
		else var_B = var_B / 12.92;

		var_R = var_R * 100;
		var_G = var_G * 100;
		var_B = var_B * 100;

		float X = (var_R * 0.4124) + (var_G * 0.3576) + (var_B * 0.1805);
		float Y = (var_R * 0.2126) + (var_G * 0.7152) + (var_B * 0.0722);
		float Z = (var_R * 0.0193) + (var_G * 0.1192) + (var_B * 0.9505);
		
		
		float r2=ClrPoints[n].r;
		float g2=ClrPoints[n].g;
		float b2=ClrPoints[n].b;
		 var_R = (float)( r2 / 255 );
		 var_G = (float)( g2 / 255 );
		 var_B = (float)( b2 / 255 );
		 
		

		if (var_R>0.04045) 
		var_R = std::pow(((var_R+0.055)/ 1.055 ), 2.4);
		else var_R = var_R / 12.92;
		if ( var_G > 0.04045 ) var_G = std::pow(( ( var_G + 0.055 ) / 1.055 ), 2.4);
		else var_G = var_G / 12.92;
		if ( var_B > 0.04045 ) var_B = std::pow(( ( var_B + 0.055 ) / 1.055 ), 2.4);
		else var_B = var_B / 12.92;

		var_R = var_R * 100;
		var_G = var_G * 100;
		var_B = var_B * 100;

		float X2 = (var_R * 0.4124) + (var_G * 0.3576) + (var_B * 0.1805);
		float Y2 = (var_R * 0.2126) + (var_G * 0.7152) + (var_B * 0.0722);
		float Z2 = (var_R * 0.0193) + (var_G * 0.1192) + (var_B * 0.9505);
		
		float var_X = X / RefX;
		float var_Y = Y / RefY;
		float var_Z = Z / RefZ;

		if ( var_X > 0.008856 ) var_X = std::pow(var_X, ( 0.3333333333333 ));
		else var_X = ( 7.787 * var_X ) + ( 16 / 116 );
		if ( var_Y > 0.008856 ) var_Y = std::pow(var_Y, ( 0.3333333333333 ));
		else var_Y = ( 7.787 * var_Y ) + ( 16 / 116 );
		if ( var_Z > 0.008856 ) var_Z = std::pow(var_Z, ( 0.3333333333333 ));
		else var_Z = ( 7.787 * var_Z ) + ( 16 / 116 );

		float L1 = ( 116 * var_Y ) - 16;
		float A1 = 500 * ( var_X - var_Y );
		float B1 = 200 * ( var_Y - var_Z );
		
		
		
		 var_X = X2 / RefX;
		 var_Y = Y2 / RefY;
		 var_Z = Z2 / RefZ;

		if ( var_X > 0.008856 ) var_X = std::pow(var_X, ( 0.3333333333333 ));
		else var_X = ( 7.787 * var_X ) + ( 16 / 116 );
		if ( var_Y > 0.008856 ) var_Y = std::pow(var_Y, ( 0.3333333333333 ));
		else var_Y = ( 7.787 * var_Y ) + ( 16 / 116 );
		if ( var_Z > 0.008856 ) var_Z = std::pow(var_Z, ( 0.3333333333333 ));
		else var_Z = ( 7.787 * var_Z ) + ( 16 / 116 );

		float L2 = ( 116 * var_Y ) - 16;
		float A2 = 500 * ( var_X - var_Y );
		float B2 = 200 * ( var_Y - var_Z );
		// std::cout << "r: " << r2 << "g: " << g2 << "b: " << b2 << " | L:" << L2 << "A: " << A2 << "B: " << B2 << std::endl; 
		re=sqrt(((L1-L2)*(L1-L2))+((A1-A2)*(A1-A2))+((B1-B2)*(B1-B2)));
		 
		 //float re=sqrt((0.3*((r-ClrPoints[n].r)*(r-ClrPoints[n].r)))+(0.59*((g-ClrPoints[n].g)*(g-ClrPoints[n].g)))+(0.11*((b-ClrPoints[n].b)*(b-ClrPoints[n].b))));
		 return re;
	 }
	 
	 int GetNearestColor(int r, int g, int b)
	 {
		float pick=99999999;
		int picked=0;
		for(int i=1; i<ActiveClrs+1; i++)
		{
			if(DistToColor(r, g, b, i)<pick)
			{
				pick=DistToColor(r, g, b, i);
				picked=i;
			}
			
		}
		return picked;
	 }
	 
	 int AddColor(int r, int g, int b, int rP=-1, int gP=-1, int bP=-1)
	 {
		 ActiveClrs++;
		 Clrs[ActiveClrs].r=r;
		 Clrs[ActiveClrs].g=g;
		 Clrs[ActiveClrs].b=b;
		 if(rP==-1)ClrPoints[ActiveClrs].r=r;
		 else ClrPoints[ActiveClrs].r=rP;
		 if(gP==-1)ClrPoints[ActiveClrs].g=g;
		 else ClrPoints[ActiveClrs].g=gP;
		 if(bP==-1)ClrPoints[ActiveClrs].b=b;
		 else ClrPoints[ActiveClrs].b=bP;
		 return 0;
	 }
	
};

Palette cPal;
Palette PaletteStack[200];
int APals=0;

int loadSettings(std::string mainfile)
{
			std::ifstream file;
	
			std::string str;
	
			file.open(mainfile.c_str());
			while (std::getline(file, str))
			{
			char * writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			if(speicher=="Jumper"){Jumper=atoi(str.c_str());}
				delete[] writable;
				speicher=str;
			}
		file.close();	
		
		return 0;
}


int loadPalettes(char* mainfile)
{
			std::ifstream file;
	
			std::string str;
	
			file.open(mainfile);
			while (std::getline(file, str))
			{
			char * writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			if(speicher=="NewPal"){APals++; PaletteStack[APals].ActiveClrs=0;}
			if(speicher=="AddColor"){PaletteStack[APals].ActiveClrs++;}
			if(speicher=="R"){PaletteStack[APals].Clrs[PaletteStack[APals].ActiveClrs].r=atoi(str.c_str()); PaletteStack[APals].ClrPoints[PaletteStack[APals].ActiveClrs].r=atoi(str.c_str());}
			if(speicher=="G"){PaletteStack[APals].Clrs[PaletteStack[APals].ActiveClrs].g=atoi(str.c_str()); PaletteStack[APals].ClrPoints[PaletteStack[APals].ActiveClrs].g=atoi(str.c_str());}
			if(speicher=="B"){PaletteStack[APals].Clrs[PaletteStack[APals].ActiveClrs].b=atoi(str.c_str()); PaletteStack[APals].ClrPoints[PaletteStack[APals].ActiveClrs].b=atoi(str.c_str());}
			if(speicher=="RP"){PaletteStack[APals].ClrPoints[PaletteStack[APals].ActiveClrs].r=atoi(str.c_str());}
			if(speicher=="GP"){PaletteStack[APals].ClrPoints[PaletteStack[APals].ActiveClrs].g=atoi(str.c_str());}
			if(speicher=="BP"){PaletteStack[APals].ClrPoints[PaletteStack[APals].ActiveClrs].b=atoi(str.c_str());}
				delete[] writable;
				speicher=str;
			}
		file.close();	
		
		return 0;
}



SDL_Surface* crop_surface(SDL_Surface* surfer, int w, int h)
{
SDL_Surface* surface = SDL_CreateRGBSurface(surfer->flags, w, h, surfer->format->BitsPerPixel, surfer->format->Rmask, surfer->format->Gmask, surfer->format->Bmask, surfer->format->Amask);
SDL_Rect rect = {0, 0, w, h};
SDL_BlitSurface(surfer, &rect, surface, 0);
return surface;
}

int CValue(SDL_Color c1)
{
	int sum=c1.r+c1.g+c1.b;
	return sum;
}

int SortColors(int Size)
{
	/*
	bool doer=true;
	while(doer==true)
	{
		doer=false;
		for(int i=0; i<Size; i++)
		{
			if(CValue(CArr[i])>CValue(CArr[i+1]))
			 {
				 std::swap(CArr[i], CArr[i+1]);
				 doer=true; 
			 }
			
		}
	}*/
	std::sort(RArr, RArr+Size);
	std::sort(BArr, BArr+Size);
	std::sort(GArr, GArr+Size);
	return 0;
}

int GetInputList()
{
	 std::string path = "Extract";
	 
    for (const auto & entry : std::filesystem::directory_iterator(path))
    {
		Pathn++;
        Paths[Pathn]=entry.path().string();
        RawImages[Pathn] = IMG_Load( entry.path().string().c_str() ); 
        //std::cout << Paths[Pathn] << std::endl;
	}
	return 0;

}

int Recoulor(SDL_Surface* Surf, SDL_Texture** give, bool clean=true, int Save=0)	//this is crazy!
{
	 std::ofstream myfile;
	 std::string stringname=Paths[Save];
	 stringname.erase(0, 8);
	 std::string appendixer="Extracts/";
	 appendixer+=stringname;
	 appendixer+=".txt";
	myfile.open (appendixer);
	myfile << "NewPal\n";
	myfile << stringname<<"\n";
	int x1=Surf->w;
    int y1=Surf->h;
	Surf=crop_surface(Surf, x1, y1);
	SDL_LockSurface(Surf);
	
    int bpp = Surf->format->BytesPerPixel;




	int c=0;

	for(int x=0; x<x1; x++)
	for(int y=0; y<y1; y++)
	{
	c++;
	if(c==Jumper)
	{
		c=0;
	 Uint8 red, green, blue, alpha;
    Uint8 *p = (Uint8*)Surf->pixels + y * Surf->pitch + x * bpp;
    Uint32 pixelColor;
    switch(bpp)
    {
        case(1):
            pixelColor = *p;
            break;
        case(2):
            pixelColor = *(Uint16*)p;
            break;
        case(3):
            if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
                pixelColor = p[0] << 16 | p[1] << 8 | p[2];
            else
                pixelColor = p[0] | p[1] << 8 | p[2] << 16;
            break;
        case(4):
            pixelColor = *(Uint32*)p;
            break;
    }
    

    
    SDL_GetRGBA(pixelColor, Surf->format, &red, &green, &blue, &alpha);
    int reO=red;
    int grO=green;
    int blO=blue;
    
     bool Check=false;
    for(int i=1; i<cNumb+1; i++)
     {
		if(CArr[i].r==red && CArr[i].b==blue && CArr[i].g==green)
		 Check=true;
	 }
	if(Check==false)
	{
    cNumb++;
    CArr[cNumb].r=red;
    CArr[cNumb].b=blue;
    CArr[cNumb].g=green;
    myfile << "AddColor\n";
	myfile << " "<<"\n";
	myfile << "R\n";
	myfile << reO <<"\n";
	myfile << "G\n";
	myfile << grO <<"\n";
	myfile << "B\n";
	myfile << blO <<"\n";
	
	}
	
	}
	}
	
	SDL_UnlockSurface(Surf);


	//if(Save>0)IMG_SavePNG(Surf, "output.png");
	
	if(clean==true)
	if((*give)!=NULL)SDL_DestroyTexture(*give);
	(*give)=SDL_CreateTextureFromSurface(Renderer, Surf);
	SDL_FreeSurface(Surf);
	
	 myfile.close();
	return 0;	

}



int iniSDL()
{
if( SDL_Init( SDL_INIT_VIDEO ) < 0 ) { printf( "SDL konnte nicht initialisiert werden: %s\n", SDL_GetError() ); }
		else { 
		 if( !SDL_SetHint( SDL_HINT_RENDER_SCALE_QUALITY, "1" ) ) { printf( "Warning: Linear texture filtering not enabled!" ); }
		if(AntiA==true)
		{
		SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
		SDL_GL_SetAttribute(SDL_GL_MULTISAMPLEBUFFERS, 1);
	    SDL_GL_SetAttribute(SDL_GL_MULTISAMPLESAMPLES, 2);
		SDL_GL_SetAttribute(SDL_GL_ACCELERATED_VISUAL, 1);
		}
		  for(int i = 0; i < SDL_GetNumVideoDisplays(); ++i)
		{
		
		int should_be_zero = SDL_GetCurrentDisplayMode(i, &DMode);

		 if(should_be_zero != 0)
  	
 	    SDL_Log("SDL-Fehler bei der Ausgabe #%d: %s", i, SDL_GetError());

		 else
 	   

		
	   SDL_Log("Anzeige #%d: Modus: %dx%dpx @ %dhz. \n", i, DMode.w, DMode.h, DMode.refresh_rate);
		  }
 
		}
				if(FullScreen==1)
			  Window=SDL_CreateWindow("Acid Flight", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_FULLSCREEN | SDL_WINDOW_OPENGL ); 
		else if(FullScreen==2)
			  Window=SDL_CreateWindow("Acid Flight", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_BORDERLESS | SDL_WINDOW_OPENGL ); 
		else if(FullScreen==0)
			Window=SDL_CreateWindow("Acid Flight", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_OPENGL | SDL_WINDOW_RESIZABLE ); 
		
	Renderer = SDL_CreateRenderer( Window, -1, SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC ); 
		    
		
		 SDL_RenderSetLogicalSize(Renderer, 1920, 1080);
		 ScreenSurface = SDL_GetWindowSurface( Window );
		if(FullScreen==1)
			SDL_SetWindowFullscreen(Window, SDL_WINDOW_FULLSCREEN);
		if(FullScreen==2)
			SDL_SetWindowFullscreen(Window, SDL_WINDOW_BORDERLESS);
			
			     SDL_ShowCursor(SDL_DISABLE);
			     
//fonts
if( TTF_Init() == -1 ) { printf( "SDL_ttf could not initialize! SDL_ttf Error: %s\n", TTF_GetError() ); }	

//ini Sound!
if(Mono==false)
 {if( Mix_OpenAudio( 44100, MIX_DEFAULT_FORMAT, 2, 2048 ) < 0 ) { printf( "Ton-Wiedergabe nicht möglich :(: %s\n", Mix_GetError() );}}
 else
 if( Mix_OpenAudio( 44100, MIX_DEFAULT_FORMAT, 1, 2048 ) < 0 ) { printf( "Ton-Wiedergabe nicht möglich :(: %s\n", Mix_GetError() );}
	Mix_AllocateChannels(48);
	//ini gamepad
	   SDL_InitSubSystem(SDL_INIT_JOYSTICK);
	   SDL_InitSubSystem(SDL_INIT_GAMECONTROLLER);
	   SDL_SetHint(SDL_HINT_JOYSTICK_ALLOW_BACKGROUND_EVENTS,"1");
	   
	 
     SDL_ShowCursor(SDL_DISABLE);
     return 0;	
}

SDL_Texture* loadTexture( std::string path ) { 
	SDL_Texture* newTexture = NULL; 
		SDL_Surface* loadedSurface = IMG_Load( path.c_str() ); 
	if( loadedSurface == NULL ) { printf( "Unable to load image %s! SDL_image Error: %s\n", path.c_str(), IMG_GetError() ); } else { 
		newTexture = SDL_CreateTextureFromSurface( Renderer, loadedSurface ); if( newTexture == NULL ) { printf( "Unable to create texture from %s! SDL Error: %s\n", path.c_str(), SDL_GetError() ); } 
		
		SDL_FreeSurface( loadedSurface ); } return newTexture; }
		
int RecoCTex()
{
	Recoulor(RawImages[CTex], &Images[CTex], 1, CTex);
	return 0;
}

int Events()
{
	while( SDL_PollEvent( &event ) ){
		switch( event.type ){
		  case SDL_KEYDOWN:
		  {
			if(event.key.keysym.sym==SDLK_ESCAPE)
				{
					running=false;
				 }
			if(event.key.keysym.sym==SDLK_LEFT)
				{
					CTex--;
					if(CTex==0)CTex=Pathn;
					RecoCTex();
				 }
				 if(event.key.keysym.sym==SDLK_RIGHT)
				{
					CTex++;
					if(CTex>Pathn)CTex=1;
					RecoCTex();
				 }
	
				 if(event.key.keysym.sym==SDLK_KP_PLUS)
				{
					Zoomfactor=Zoomfactor+0.01;
				}
				 if(event.key.keysym.sym==SDLK_KP_MINUS)
				{
					Zoomfactor=Zoomfactor-0.01;
				}
				if(event.key.keysym.sym==SDLK_p)
				{
					if(PaletteMode==true)PaletteMode=false;
					else PaletteMode=true;
					RecoCTex();
				}
				if(event.key.keysym.sym==SDLK_c)
				{
					MedianMode++;
					if(MedianMode>2)MedianMode=0;
					RecoCTex();
				}
				if(event.key.keysym.sym==SDLK_x)
				{
					if(MedianPoint>0.05)MedianPoint=MedianPoint-0.05;
					RecoCTex();
				}
				if(event.key.keysym.sym==SDLK_v)
				{
					if(MedianPoint<0.95)MedianPoint=MedianPoint+0.05;
					RecoCTex();
				}
				
				
			 }
			 break;
		 }
		}
	return 0;	
}



int DefPals()
{
	cPal.AddColor(0, 0, 0);
	cPal.AddColor(20, 20, 20);
	cPal.AddColor(255, 0, 0);
	cPal.AddColor(0, 255, 0);
	cPal.AddColor(0, 0, 255);
	cPal.AddColor(80, 80, 80);
	cPal.AddColor(125, 80, 80);
	cPal.AddColor(80, 125, 80);
	cPal.AddColor(80, 80, 125);
	cPal.AddColor(200, 200, 230);
	cPal.AddColor(255, 200, 200);
	cPal.AddColor(200, 230, 200);
	cPal.AddColor(180, 60, 100);
	cPal.AddColor(60, 180, 100);
	cPal.AddColor(100, 180, 60);
	cPal.AddColor(255, 255, 255);
	return 0;
}

int main()
{
iniSDL();
DefPals();
loadSettings("ExSettings.txt");
cPal=PaletteStack[3];
GetInputList();

for(int i=1; i<Pathn+1; i++)
Recoulor(RawImages[i], &Images[i], 1, i);



}
